<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Initialization</TITLE>
<link href="suif1_105.html" rel=Next>
<link href="suif1_103.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_103.html">previous</A>, <A HREF="suif1_105.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC104" HREF="suif1_toc.html#TOC104">Initialization and Finalization</A></H2>
<P>
<A NAME="IDX733"></A>
<A NAME="IDX734"></A>
<A NAME="IDX735"></A>

</P>
<P>
<A NAME="IDX736"></A>
Before using any features of the SUIF library, a program must first
initialize it.  The <CODE>init_suif</CODE> function, defined in the
<TT>`initsuif.h'</TT> and <TT>`initsuif.cc'</TT> files, performs this
initialization.  The <CODE>main</CODE> function of a SUIF program should call
<CODE>init_suif</CODE> first.  The <CODE>argc</CODE> and <CODE>argv</CODE> parameters are
passed to <CODE>init_suif</CODE> so that it can check for the following
standard options:

</P>
<DL COMPACT>

<DT><CODE>-version</CODE>
<DD>
Print the version numbers and compilation information for the program
and for any libraries with which it is linked.  The
<CODE>prog_ver_string</CODE> and <CODE>prog_who_string</CODE> strings contain the
version number and compilation information for the program.  They are
usually set automatically by the standard SUIF makefiles.  Similarly,
the <CODE>libsuif1_ver_string</CODE> and <CODE>libsuif1_who_string</CODE> strings
are used for the SUIF library.  Information for other libraries is
recorded when they are registered (as described below).

<DT><CODE>-print-flat</CODE>
<DD>
Do not print structured annotations (see section <A HREF="suif1_72.html#SEC72">Structured Annotations</A>) using
the user-defined printing functions.  If all annotations are printed as
flat lists of immediate values, the output could be parsed and converted
back to a binary SUIF file.

<DT><CODE>-no-types</CODE>
<DD>
Do not print the result types for instructions.  This is just to help
make the output more readable in situations where the result types are
not of interest.

<DT><CODE>-no-symtabs</CODE>
<DD>
Do not print out symbol tables.  If the symbolic information is not
needed, this makes the output shorter and easier to read.
</DL>

<P>
These options are potentially applicable to all SUIF programs, so they
are included in the library.

</P>
<P>
<A NAME="IDX737"></A>
At the end of a SUIF program, the data structures in the SUIF library
may be deallocated.  Although this is not absolutely necessary, it may
simplify debugging by making it easier to read the output from Purify
and other tools.  Besides deallocating the data structures, it may
someday be useful to perform other actions at the end of a SUIF program.
The <CODE>exit_suif</CODE> function is provided to perform this finalization.
If used, it should be called at the very end of the program.

</P>
<P>
<A NAME="IDX738"></A>
<A NAME="IDX739"></A>
<A NAME="IDX740"></A>
Besides the base SUIF library, many SUIF programs are linked with other
libraries that also need to be initialized.  Rather than just
initializing them directly, they are registered with the SUIF library
along with initialization and finalization functions.  The
initialization functions are then called automatically by
<CODE>init_suif</CODE> and the finalization functions by <CODE>exit_suif</CODE>.
This allows the SUIF library to record and print version numbers and
other information for all of the libraries linked with a program.  The
<CODE>register_library</CODE> function records the name, version, and
compilation information for a library along with pointers to the
functions to initialize and finalize that library.  The initialization
function must match the <CODE>lib_init_f</CODE> type, which takes the
<CODE>argc</CODE> and <CODE>argv</CODE> parameters for the command line and returns
<CODE>void</CODE>.  Similarly, the finalization function must match the
<CODE>lib_exit_f</CODE> type, which takes no arguments and returns
<CODE>void</CODE>.  The parameters for the name, version, and compilation
information are required, but the initialization and finalization
functions are optional.  The libraries must be registered, in the order
in which they should be initialized, before calling <CODE>init_suif</CODE>.
The finalization functions are called in the reverse order in which the
libraries were registered.

</P>
<P>
<A NAME="IDX741"></A>
<A NAME="IDX742"></A>
The situation is much simpler if you use the standard SUIF makefiles.
These makefiles automatically generate strings holding the version and
compilation information.  The <CODE>LIBRARY</CODE> macro may be used to
register a library using these version strings.  You only need to
specify the base name of the library and the names of the initialization
and finalization functions <A NAME="DOCF7" HREF="suif1_foot.html#FOOT7">(7)</A>.  To make things even easier, the
SUIF makefiles also generate a new function called <CODE>start_suif</CODE>.
This function automatically registers all of the libraries linked with
the program and then calls <CODE>init_suif</CODE>.  So to make a long story
short, if a SUIF program begins with a call to <CODE>start_suif</CODE> all of
the libraries will be automatically registered and initialized.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_103.html">previous</A>, <A HREF="suif1_105.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
